import { Observable, PartialObserver as Listener, Subscription } from 'rxjs'
import { PushEvent } from './baseTypes'
export { Listener, Subscription }
export interface UseEvent {
    (eventName: string): [Observable<void>, () => any]
    <T = any>(eventName: string, seedValue?: T): [
        Observable<T>,
        (val: T) => any
    ]
}
export interface FromEvent {
    (eventName: string): Observable<void>
    <T>(eventName: string, valueTransformer?: (val: any) => T): Observable<T>
}
export interface ObservableComponentBase {
    mount: Observable<any>
    unmount: Observable<any>
    fromEvent: FromEvent
    pushEvent: PushEvent
    useEvent: UseEvent
}
export interface Observe {
    observe: <T>(
        propName?: string,
        valueTransformer?: (val: any) => T
    ) => Observable<T>
}
export declare type ObservableComponent = Observe & ObservableComponentBase
export declare type Aperture<P, E, C = any> = (
    component: ObservableComponent,
    initialProps: P,
    initialContext?: C
) => Observable<E>
export declare const subscribeToSink: <T>(
    sink: Observable<T>,
    next: (val: T) => void,
    error?: (error: any) => void
) => Subscription
export declare const createObservable: (
    subscribe: any
) => {
    [x: string]: any
    subscribe: any
}
export declare const getObserve: <P>(
    getProp: any,
    data: any,
    decoratedProps: any
) => <T>(propName?: any, valueTransformer?: any) => any
export declare const createComponent: <P>(
    getProp: any,
    dataObservable: any,
    pushEvent: PushEvent,
    decoratedProps: boolean
) => ObservableComponent
